unit twfexp_u1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, twfdec, XPMan, Shlobj, Ole2, ComCtrls;

type
  TFrmMain = class(TForm)
    Label1: TLabel;
    EdtTWFFile: TEdit;
    BtnTWFFile: TButton;
    GbpOutputSettings: TGroupBox;
    Label2: TLabel;
    EdtWritePath: TEdit;
    BtnWritePath: TButton;
    Label3: TLabel;
    ChkMode1: TCheckBox;
    ChkMode2: TCheckBox;
    ChkMode3: TCheckBox;
    ChkMode4: TCheckBox;
    ChkMode5: TCheckBox;
    ChkMode6: TCheckBox;
    ChkMode7: TCheckBox;
    ChkMode8: TCheckBox;
    ChkMode9: TCheckBox;
    Label4: TLabel;
    RbtOutput1: TRadioButton;
    RbtOutput2: TRadioButton;
    RbtOutput3: TRadioButton;
    ChkSingleMemos: TCheckBox;
    ChkOWBExtensions: TCheckBox;
    BtnExport: TButton;
    BtnCancel: TButton;
    BtnAbout: TButton;
    XPManifest: TXPManifest;
    OpdTWFFile: TOpenDialog;
    GpbMessages: TGroupBox;
    RedMessages: TRichEdit;
    procedure BtnAboutClick(Sender: TObject);
    procedure BtnExportClick(Sender: TObject);
    procedure BtnWritePathClick(Sender: TObject);
    procedure BtnTWFFileClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure UpdateFormElements(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}


procedure TFrmMain.BtnAboutClick(Sender: TObject);
begin
  Application.MessageBox (PChar('TWFExporter v1.01'#10#10
                              + '(c) 2006 by AUDACIA Software'#10
                              + 'Based on TWV2CSV, (c) 1996-2003 by Zoltan Babos'#10#10
                              + 'www.audacia-software.de'),
                          'About TWFExporter', MB_ICONINFORMATION);
end;

procedure TFrmMain.BtnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure printMessage (msg: PChar; i : Integer); stdcall;
var
  frm : TFrmMain;
begin
  frm := TFrmMain (i);
  frm.RedMessages.Lines.Add (msg);
  frm.Refresh;
end;

procedure TFrmMain.BtnExportClick(Sender: TObject);
var
  twfflags, decflags : Integer;
begin
  RedMessages.Lines.Clear;

  twfflags := 0;
  decflags := 0;

  if ChkMode1.Checked then
    twfflags := twfflags or twfSchedule;
  if ChkMode2.Checked then
    twfflags := twfflags or twfTodo;
  if ChkMode3.Checked then
    twfflags := twfflags or twfReminder;
  if ChkMode4.Checked then
    twfflags := twfflags or twfBusiness;
  if ChkMode5.Checked then
    twfflags := twfflags or twfPersonal;
  if ChkMode6.Checked then
    twfflags := twfflags or twfContacts;
  if ChkMode7.Checked then
    twfflags := twfflags or twfMemo;
  if ChkMode8.Checked then
    twfflags := twfflags or twfSketch;
  if ChkMode9.Checked then
    twfflags := twfflags or twfExpense;

  if RbtOutput1.Checked then
    decflags := decDDLinkCSV;
  if RbtOutput2.Checked then
    decflags := decExcelCSV;
  if RbtOutput3.Checked then
    decflags := decTXT;

  if ChkSingleMemos.Checked then
    decflags := decflags or decSingleMemo;
  if ChkOWBExtensions.Checked then
    decflags := decflags or decOWBExtensions;

  decodeTWFFile (PChar (EdtWritePath.Text), PChar (EdtTWFFile.Text), twfflags,
                 decflags, printMessage, Integer (FrmMain));
end;

procedure TFrmMain.BtnTWFFileClick(Sender: TObject);
begin
  if not OpdTWFFile.Execute then exit;
  EdtTWFFile.Text := OpdTWFFile.FileName;
  UpdateFormElements (Sender);
end;

procedure TFrmMain.BtnWritePathClick(Sender: TObject);
var
  bi : BROWSEINFO;
  buf : array[0..MAX_PATH - 1] of Char;
  iidl : PItemIDList;

begin
  bi.hwndOwner      := Handle;
  bi.pidlRoot       := nil;
  bi.pszDisplayName := buf;
  bi.lpszTitle      := 'Please select output directory:';
  bi.ulFlags        := BIF_EDITBOX or BIF_NEWDIALOGSTYLE;
  bi.lpfn           := nil;

  OleInitialize (nil);
  CoInitialize (nil);
  iidl := SHBrowseForFolder (bi);
  if iidl <> nil then
  begin
    if SHGetPathFromIDList (iidl, buf) then
      EdtWritePath.Text := String (buf);
  end;
  CoUninitialize ();
  OleUninitialize ();

  UpdateFormElements (Sender);
end;

procedure TFrmMain.UpdateFormElements(Sender: TObject);
begin
  ChkSingleMemos.Enabled := ChkMode7.Checked and RbtOutput3.Checked;
  ChkOWBExtensions.Enabled := ChkSingleMemos.Enabled and ChkSingleMemos.Checked;
  BtnExport.Enabled := (EdtTWFFile.Text <> '') and (EdtWritePath.Text <> '') and
      (ChkMode1.Checked
    or ChkMode2.Checked
    or ChkMode3.Checked
    or ChkMode4.Checked
    or ChkMode5.Checked
    or ChkMode6.Checked
    or ChkMode7.Checked
    or ChkMode8.Checked
    or ChkMode9.Checked);
  end;

end.
